--
-- Created by IntelliJ IDEA.
-- User: Jens
-- Date: 24.03.14
-- Time: 10:51
-- To change this template use File | Settings | File Templates.
--
PimpMyProfession = LibStub("AceAddon-3.0"):NewAddon("PimpMyProfession", "AceConsole-3.0", "AceEvent-3.0" );

local PimpMyProfession = _G.PimpMyProfession
local AceLocale = LibStub("AceLocale-3.0")
local L = AceLocale:GetLocale("PimpMyProfession")
local _
local MainFrame
local Default_Profile = {
    profile = {
        Colors = {
            ["Window"] = {
                ["Title"] = {r=1, g=0, b=0, a=1},
                ["Background"] = {r=24/255, g=24/255, b=24/255, a=1},
                ["Title Text"] = {r=1, g=1,b=1,a=1},
            },
        },
        MainProfessions={},
        Fishing = {},
        Cooking = {},
        FirstAid = {},
        Archaeology = {},
        Font="Arial Narrow",
        ClampToScreen=false,
        ShowMainOnStart = true,
        ShowNListOnStart = false,
        LastProfGuide = {}
    },
}
local mainprof = {
    gathering = {182, 186, 393 },
    production = {
        164, 165, 171, 197, 202, 333, 755, 773
    }
}
local secprof = {
    129, 184, 356,794
}
local profCount=0
PimpMyProfession.professions = {}
local fullInit = false
PimpMyProfession.Version =  "1.0.7"
PimpMyProfession.consoleOptions = {
    name=L["PimpMyProfession"],
    type = 'group',
    args = {
        [L["show"]] = {
            order = 1,
            name=L["Show"],
            desc=L["Show the MainWindow"],
            type = 'execute',
            func = function() PimpMyProfession.MainWindow:Show(); PimpMyProfession:RefreshMainWindow() end,
            dialogHidden = true,
        },
        hide = {
            order = 2,
            name = L["Hide"],
            desc = L["Hide the MainWindow"],
        },
    },
}
PimpMyProfession.actualGuide = {}


function PimpMyProfession:OnInitialize()
    local AceDb = LibStub:GetLibrary("AceDB-3.0")
    PimpMyProfession.db = AceDb:New("PimpMyProfessionDB", Default_Profile)
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    print("PimpMyProfession wurde geladen")
end

function PimpMyProfession:OnEnable()
    self:RegisterEvent('SKILL_LINES_CHANGED')
    print("PimpMyProfession wurde aktiviert")
    --PimpMyProfession:CreateMainProfessionFrame()

 end

function PimpMyProfession:CreateMainFrame()
    MainFrame = CreateFrame("Frame",nil, UIParent)
    MainFrame:ClearAllPoints()
    MainFrame:SetClampedToScreen(true)
    MainFrame:EnableMouse(true)
    MainFrame:SetMovable(true)
    MainFrame:SetWidth(640)
    MainFrame:SetHeight(480)
    MainFrame:SetPoint("CENTER",UIParent)
    MainFrame:SetBackdrop{
        bgFile = [[Interface\ToolTips\ChatBubble-Background.blp]],
        edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
        edgeSize = 16,
        tile = true, tileSize = 16,
        insets = {left = 4, right = 4, top = 4, bottom = 4}
    }

    local tr = MainFrame:CreateTitleRegion()
    tr:SetAllPoints(MainFrame)

    local header = MainFrame:CreateTexture(nil,"ARTWORK")
    header:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
    header:SetWidth(256); header:SetHeight(64)
    header:SetPoint("TOP", 0, 12)

    local title = MainFrame:CreateFontString("ARTWORK")
    title:SetFontObject("GameFontNormal")
    title:SetPoint("TOP", header, "TOP", 0, -14)
    title:SetText(L["PimpMyProfession"])

    local ProfTitleFont = CreateFont("ProfTitleFontLarge")
    ProfTitleFont:CopyFontObject(GameFontHighlight)
    ProfTitleFont.font = ProfTitleFont:GetFont()
    ProfTitleFont:SetFont(ProfTitleFont.font,18,"OUTLINE")
    ProfTitleFont:SetShadowColor(0,0,0)
    ProfTitleFont:SetShadowOffset(3,-2)

    --hier kommen die 2 Frames der Hauptberufe  rein
    local mpTitle = MainFrame:CreateFontString(nil, "OVERLAY", "ProfTitleFontLarge")
    mpTitle:SetPoint("TOPLEFT",MainFrame, "TOPLEFT", 10,-30)
    mpTitle:SetText(L["MainProfession"])

    PimpMyProfession:CreateMainProfessionFrame()

    --hier die 4 Fenster der Nebenberufe wie Kochen,
    --Angeln, Erste Hilfe, Ärcheologie
    local spTitle = MainFrame:CreateFontString(nil, "OVERLAY", "ProfTitleFontLarge")
    spTitle:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 10, -160)
    spTitle:SetText(L["SecondProfessions"])
    PimpMyProfession:CreateSecondProfessionFrame()

    --zum Schluss noch der Schliessenbutton
    MainFrame.close = CreateFrame("CheckButton", "Main_Close", MainFrame, "OptionsButtonTemplate")
    MainFrame.close:SetText(L["Close"])
    MainFrame.close:SetScript("OnClick", function(self)
        MainFrame:Hide()
    end)
    MainFrame.close:SetPoint("BOTTOMRIGHT", -14,14)

end

function PimpMyProfession:CreateMainProfessionFrame()
    local s = 1
    local width = MainFrame:GetWidth()/2
    local anz = 0
        for index, prof in pairs(PimpMyProfession.professions) do
            if (prof.isMain) then
                if(s == 1) then
                    PimpMyProfession:GetProfessionInfoFrame(prof, MainFrame, s, "TOPLEFT", 8,-50)
                else
                    PimpMyProfession:GetProfessionInfoFrame(prof, MainFrame, s, "TOPRIGHT", -8, -50)
                end
                anz = anz +1
            end
            s= s+1
        end
    if (anz == 0) then
        PimpMyProfession:GetProfessionInfoFrame(nil, MainFrame, s, "TOPLEFT", 8,-50)
        PimpMyProfession:GetProfessionInfoFrame(nil, MainFrame, s, "TOPRIGHT", -8, -50)
    elseif(anz == 1) then
        PimpMyProfession:GetProfessionInfoFrame(nil, MainFrame, s, "TOPRIGHT", -8, -50)
    end

end

function PimpMyProfession:CreateSecondProfessionFrame()
    --erste Hilfe
    for i=3,6 do
       local beruf = select(i,GetProfessions())
        if(beruf ~= nil) then
            local name = select(1, GetProfessionInfo(beruf))
            if i== 3 or i == 5 then
                if i == 3 then
                    PimpMyProfession:GetProfessionInfoFrame(PimpMyProfession.professions[name],MainFrame, i, "TOPLEFT", 8,-180)
                else
                    PimpMyProfession:GetProfessionInfoFrame(PimpMyProfession.professions[name], MainFrame, i, "TOPLEFT", 8, -280)
                end
            else
               if i == 4 then
                   PimpMyProfession:GetProfessionInfoFrame(PimpMyProfession.professions[name], MainFrame, i, "TOPRIGHT", -8, -180)
               else
                   PimpMyProfession:GetProfessionInfoFrame(PimpMyProfession.professions[name], MainFrame, i, "TOPRIGHT", -8, -280)
               end
            end
        else
            if i== 3 or i == 5 then
                if i == 3 then
                    PimpMyProfession:GetProfessionInfoFrame(nil,MainFrame, i, "TOPLEFT", 8,-180)
                else
                    PimpMyProfession:GetProfessionInfoFrame(nil, MainFrame, i, "TOPLEFT", 8, -280)
                end
            else
                if i == 4 then
                    PimpMyProfession:GetProfessionInfoFrame(nil, MainFrame, i, "TOPRIGHT", -8, -180)
                else
                    PimpMyProfession:GetProfessionInfoFrame(nil, MainFrame, i, "TOPRIGHT", -8, -280)
                end
            end

        end

    end
end

function PimpMyProfession:GetProfessionInfoFrame(profession, frame, index, layer, offX, offY)
    --Name des Berufes
    local fName = CreateFont("BerufNameFontNormal")
    fName:CopyFontObject(GameFontNormal)
    fName.font = fName:GetFont()
    fName:SetFont(fName.font, 16)

    local width = frame:GetWidth() / 2
    local f = CreateFrame("Frame", "profframe"..index, frame)
    f:SetWidth(width - 8)
    f:SetHeight(100)
    f:SetPoint(layer, offX, offY)
    f:SetBackdrop{
        bgFile = [[Interface\ToolTips\ChatBubble-Background.blp]],
        edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
        edgeSize = 16,
        tile = true, tileSize = 16,
        insets = {left = 4, right = 4, top = 4, bottom = 4}
    }

    if(profession ~= nil) then
        -- Anlegen des Berufeicon's
        f.icon = f:CreateTexture(nil, 'ARTWORK')
        f.icon:SetHeight(48)
        f.icon:SetWidth(48)
        f.icon:SetPoint("LEFT",10,0)
        f.icon:SetTexture(profession.icon)

        --Anlegen der Anzeige für den namen des Berufes und der Statusbar
        local pFrame = CreateFrame("Frame", "pframe"..index, f)
        pFrame:SetWidth(width - f.icon:GetWidth() - 64)
        pFrame:SetHeight(f.icon:GetHeight())
        pFrame:SetPoint("LEFT",f.icon,"RIGHT",4,0)

        local pName = pFrame:CreateFontString(nil,"BACKGROUND", "BerufNameFontNormal")
        pName:SetPoint("TOPLEFT",pFrame,0,4)
        pName:SetWidth(pFrame:GetWidth() - 4)
        pName:SetJustifyH("LEFT")
        pName:SetText(profession.name)

        local pBar = CreateFrame("StatusBar", nil, pFrame)
        pBar:SetBackdrop{
            bgFile = "Interface\\TARGETINGFRAME\\UI-StatusBar"
        }
        pBar:SetPoint("BOTTOMLEFT",pFrame,0,4)
        pBar:SetWidth(pFrame:GetWidth() - 4)
        pBar:SetHeight(20)
        pBar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
        pBar:GetStatusBarTexture():SetHorizTile(false)
        pBar:GetStatusBarTexture():SetVertTile(false)
        pBar:SetMinMaxValues(0, profession.maxrank)
        pBar:SetValue(profession.rank)
        pBar:SetStatusBarColor(70/255,94/255,202/255,0.66)

        local rankText = pBar:CreateFontString(nil, "OVERLAY","GameFontHighlightSmall")
        rankText:SetPoint("CENTER", pBar,"CENTER",2)
        rankText:SetJustifyH("LEFT")
        rankText:SetText(profession.rank.." / "..profession.maxrank)

        local guideButton = CreateFrame("Button", "gbutton"..profession.skillline,f, "OptionsButtonTemplate")
        guideButton.profession = profession
        guideButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Up")
        guideButton:SetDisabledTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Disabled")
        guideButton:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Down")
        guideButton:SetWidth(32)
        guideButton:SetHeight(32)
        guideButton:SetPoint("RIGHT",f,-10,0)
        guideButton:SetScript("OnClick", function(self, button)
            local prof = self.profession
            local Guide = PimpMyProfession:GetModule("Guide")
            print("Guide für "..prof.name.." wurde geladen...")
            if(prof ~= nil) then
                --laden des Guides und übergabe als aktueller Guide
                PimpMyProfession.actualGuide = Guide:GetGuide(prof.skillline)
                PimpMyProfession:GetNeedList2(self.profession)
            end
        end)

    else
      --Anzeige das der Player erst zum Lehrer gehen muss
        local pNoProf =  f:CreateFontString(nil, "ARTWORK", "GameFontNormal")
        pNoProf:SetWidth(width - 4)
        pNoProf:SetPoint("CENTER", f)
        pNoProf:SetText(L["No MainProfession Available"])
    end
end

function PimpMyProfession:SKILL_LINES_CHANGED()
    --Hauptberufe laden
    local anz = 0
    for index, key in pairs({GetProfessions()}) do
        local name, icon, rank, maxrank, numspells, spelloffset, skillline = GetProfessionInfo(key)
        PimpMyProfession.professions[name]={
            name = name,
            icon = icon,
            rank = rank,
            maxrank = maxrank,
            numspells = numspells,
            spelloffset = spelloffset,
            skillline = skillline,
            isMain = false,
            isGather = false
        }
        anz = anz + 1
        if (index == 1 or index == 2) then
            PimpMyProfession.professions[name].isMain = true
        end
        for k,v in pairs(mainprof.gathering) do
            if skillline == v then
               PimpMyProfession.professions[name].isGather = true
            end
        end
    end
    profCount = anz
end

function PimpMyProfession:PLAYER_ENTERING_WORLD()
    PimpMyProfession:SKILL_LINES_CHANGED()
    local myrank = 0
    for index, key in pairs(PimpMyProfession.professions) do
        if key.skillline == 171 then
            myrank = key.rank
        end
    end

    PimpMyProfession:CreateMainFrame()
    PimpMyProfession.MainFrame = MainFrame

    if not PimpMyProfession.db.profile.ShowMainOnStart then
        PimpMyProfession.MainFrame:Hide()
    end
    PimpMyProfession.MiniIcon.Reposition()

    --TODO dies wird hier später ersetzt durch den aktuell gesetzten Beruf


--[[
    PimpMyProfession.NlistFrame = PimpMyProfession:CreateNeedListFrame(171,myrank)
    if not PimpMyProfession.db.profile.ShowNListOnStart then
        PimpMyProfession.NlistFrame:Hide()
    end
]]
end

function PimpMyProfession:SetSkillProfession(skill, profession)
    professions[profession] = skill
    if fullInit then self:SKILL_LINES_CHANGED() end
end